"""Subclass of BWin, which is generated by wxFormBuilder."""

import copy

import wx

import CL
import UCommon
from URubberBand import URubberBand

# Implementing BWin
class UBWin(URubberBand, CL.BWin ):
	def __init__( self, parent ):
		CL.BWin.__init__( self, parent )
		URubberBand.__init__(self, self.m_bitmap1)
		self.parent = parent  # 親ウインドウの関数を使うため

	# Handlers for BWin events.
	def OnMvEnd( self, event ):
		# TODO: Implement OnMvEnd
		pos = self.GetPosition()
		self.parent.ChildWinPoint = pos + wx.Point(20,20)

	def OnOpen( self, event ):
		# TODO: Implement OnOpen
		self.parent.OpenImgFile()

	def OnSaveAs( self, event ):
		# TODO: Implement OnSaveAs
		UCommon.SaveAs(self)

	def OnWClose( self, event ):
		# TODO: Implement OnWClose
		self.Close()

	def OnExit( self, event ):
		# TODO: Implement OnExit
		self.parent.OnExit(event)

	def OnCopy( self, event ):
		# TODO: Implement OnCopy
		UCommon.CopyToClipboard(self.cv_image)

	def OnPaste( self, event ):
		# TODO: Implement OnPaste
		self.parent.CopyFromClipboard()

	def OnZoomIn( self, event ):
		# TODO: Implement OnZoomIn
		UCommon.ZoomIn(self)

	def OnZoomOut( self, event ):
		# TODO: Implement OnZoomOut
		UCommon.ZoomOut(self)

	def OnZoomRst( self, event ):
		# TODO: Implement OnZoomRst
		UCommon.ZoomRst(self)

	def OnViewLog( self, event ):
		# TODO: Implement OnViewLog
		self.parent.LogDlg.DispLog(self.cv_image)

	def OnGray( self, event ):
		# TODO: Implement OnGray
		self.parent.NewGrayWindow(self.cv_image.grayscale(), self.magnification)
		self.parent.SetWinTitle(self)

	def OnBitwise( self, event ):
		# TODO: Implement OnBitwise
		self.parent.NewBinWindow(self.cv_image.bitwise_not(), self.magnification)
		self.parent.SetWinTitle(self)

	def OnContours( self, event ):
		# TODO: Implement OnContours
		win = self.parent.NewBinWindow(self.cv_image, self.magnification)
		self.parent.ContoursDlg.cv_image = win.cv_image
		self.parent.ContoursDlg.bitmap   = win.m_bitmap1
		self.parent.ContoursDlg.magnification = win.magnification
		ret = self.parent.ContoursDlg.ShowModal()
		# Contoursだけ特別
		if ret == 0:
			win.Destroy()
		else:
			win.cv_image = copy.deepcopy(self.parent.ContoursDlg.cv_image)
			self.parent.SetWinTitle(win)

	def OnEdge( self, event ):
		# TODO: Implement OnEdge
		win = self.parent.NewColorWindow(self.cv_image, self.magnification)
		self.parent.EdgeDlg.cv_image = win.cv_image
		self.parent.EdgeDlg.bitmap   = win.m_bitmap1
		self.parent.EdgeDlg.magnification = win.magnification
		ret = self.parent.EdgeDlg.ShowModal()
		if ret == 1:
			win.cv_image = copy.deepcopy(self.parent.EdgeDlg.cv_image)
			self.parent.SetWinTitle(win)
		else:
			win.Destroy()

	def OnBinOp( self, event ):
		# TODO: Implement OnBinOp
		win = self.parent.NewBinWindow(self.cv_image, self.magnification)
		self.parent.BinOpDlg.cv_image = win.cv_image
		self.parent.BinOpDlg.bitmap   = win.m_bitmap1
		self.parent.BinOpDlg.magnification = win.magnification
		ret = self.parent.BinOpDlg.ShowModal()
		if ret == 1:
			win.cv_image = copy.deepcopy(self.parent.BinOpDlg.cv_image)
			self.parent.SetWinTitle(win)
		else:
			win.Destroy()

	def OnHough( self, event ):
		# TODO: Implement OnHough
		pass

	def OnOp( self, event ):
		# TODO: Implement OnOp
		self.parent.OpDlg.SetChoice(self.GetTitle())
		win = self.parent.NewColorWindow(self.cv_image, self.magnification)
		self.parent.OpDlg.cv_image = win.cv_image
		self.parent.OpDlg.bitmap   = win.m_bitmap1
		self.parent.OpDlg.magnification = win.magnification
		ret = self.parent.OpDlg.ShowModal()
		if ret == 1:
			win.cv_image = copy.deepcopy(self.parent.OpDlg.cv_image)
			self.parent.SetWinTitle(win)
		else:
			win.Destroy()

	def OnDistH( self, event ):
		# TODO: Implement OnDistH
		self.cv_image.projection_distribution_h()
		self.parent.RetDlg.DistResult(self.cv_image)
		UCommon.showDist(self.cv_image)

	def OnDistV( self, event ):
		# TODO: Implement OnDistV
		self.cv_image.projection_distribution_v()
		self.parent.RetDlg.DistResult(self.cv_image)
		UCommon.showDist(self.cv_image)

	def OnHistArea( self, event ):
		# TODO: Implement OnHistArea
		self.SetCursor(wx.Cursor(wx.CURSOR_CROSS))
		self.draw_type = URubberBand.Rectangle
		self.func_type = URubberBand.HistArea

	def OnDistHArea( self, event ):
		# TODO: Implement OnDistHArea
		self.SetCursor(wx.Cursor(wx.CURSOR_CROSS))
		self.draw_type = URubberBand.Rectangle
		self.func_type = URubberBand.DistHArea

	def OnDistVArea( self, event ):
		# TODO: Implement OnDistVArea
		self.SetCursor(wx.Cursor(wx.CURSOR_CROSS))
		self.draw_type = URubberBand.Rectangle
		self.func_type = URubberBand.DistVArea

	def OnLine( self, event ):
		# TODO: Implement OnLine
		self.SetCursor(wx.Cursor(wx.CURSOR_CROSS))
		self.draw_type = URubberBand.Line
		self.func_type = URubberBand.DistLine

	def OnPixcel( self, event ):
		# TODO: Implement OnPixcel
		self.parent.PixDlg.Show(True)

	def OnLabel( self, event ):
		# TODO: Implement OnLabel
		win = self.parent.NewLabelWindow(self.cv_image, self.magnification)
		self.parent.LabelDlg.cv_image = win.cv_image
		self.parent.LabelDlg.bitmap   = win.m_bitmap1
		self.parent.LabelDlg.magnification = win.magnification
		ret = self.parent.LabelDlg.ShowModal()
		if ret == 1:
			win.cv_image = copy.deepcopy(self.parent.LabelDlg.cv_image)
#			self.parent.SetWinTitle(win)
			win.SetTitle('ラベリング処理結果')
		else:
			win.Destroy()

	def OnAbout( self, event ):
		# TODO: Implement OnAbout
		UCommon.About()

	def OnLDwn( self, event ):
		# TODO: Implement OnLDwn
		if self.parent.PixDlg.IsShown():  # ピクセル表示ならば
			pos = event.GetPosition()
			x = int(pos.x / self.magnification)
			y = int(pos.y / self.magnification)
			self.parent.PixDlg.View(self, x, y)
		if self.draw_type != URubberBand.NoRubber:  # ラバーバンド表示ならば
			URubberBand.OnMLDown(self,  event )

	def OnLUp( self, event ):
		# TODO: Implement OnLUp
		if self.drag_flag:
			URubberBand.OnMLUp( self, event )
			self.SetCursor(wx.Cursor(wx.CURSOR_ARROW))
			bx = int(self.begin_pos.x / self.magnification)
			by = int(self.begin_pos.y / self.magnification)
			ex = int(self.end_pos.x   / self.magnification)
			ey = int(self.end_pos.y   / self.magnification)
			if   self.func_type == URubberBand.HistArea:
				wx.MessageBox('２値画像はヒストグラムをサポートしていません','情報',wx.ICON_INFORMATION)
			elif self.func_type == URubberBand.DistHArea:
				self.cv_image.projection_distribution_h(bx, by, ex, ey)
				self.parent.RetDlg.DistResult(self.cv_image, bx, by, ex, ey)
				UCommon.showDist(self.cv_image)
			elif self.func_type == URubberBand.DistVArea:
				self.cv_image.projection_distribution_v(bx, by, ex, ey)
				self.parent.RetDlg.DistResult(self.cv_image, bx, by, ex, ey)
				UCommon.showDist(self.cv_image)
			elif self.func_type == URubberBand.DistLine:
				self.cv_image.get_line_data(bx, by, ex, ey)
				self.parent.RetDlg.GetLineResult(self.cv_image, bx, by, ex, ey)
				UCommon.showLine(self.cv_image)

	def OnMove( self, event ):
		# TODO: Implement OnMove
		if self.drag_flag:
			if self.parent.PixDlg.IsShown():  # ピクセル表示ならば
				pos = event.GetPosition()
				x = int(pos.x / self.magnification)
				y = int(pos.y / self.magnification)
				self.parent.PixDlg.View(self, x, y)
			URubberBand.OnMMotion( self, event )
