"""Subclass of CvtColorDlg, which is generated by wxFormBuilder."""

import wx

import CL
import UCommon
from UOpenCV import UOpenCV

# Implementing CvtColorDlg
class UCvtColorDlg( CL.CvtColorDlg ):
	def __init__( self, parent ):
		CL.CvtColorDlg.__init__( self, parent )
		self.code = [ "X(XYZ)", "Y(XYZ)", "Z(XYZ)", "Y(YCrCb)", "Cr(YCrCb)", "Cb(YCrCb)", "H(HSV)", "S(HSV)", "V(HSV)", "H(HLS)", "L(HLS)", "S(HLS)", "L(Lab)", "a(Lab)", "b(Lab)", "L(Luv)", "u(Luv)", "v(Luv)", "Y(YUV)", "U(YUV)", "V(YUV)", "B(BGR)", "G(BGR)", "R(BGR)" ]

	# Handlers for CvtColorDlg events.
	def OnCancel( self, event ):
		# TODO: Implement OnCancel
		self.EndModal(0)

	def OnPreView( self, event ):
		# TODO: Implement OnPreView
		self.Execute(False)

	def OnExec( self, event ):
		# TODO: Implement OnExec
		self.Execute(True)
		self.EndModal(1)

	def Execute(self, Flag):
		"""処理実行
		"""
		code_num = self.m_radioBox5.GetSelection()
		code = self.code[code_num]
		try:
			if Flag:
				self.cv_image = self.cv_image.cvtColor(code)
				self.bitmap.SetBitmap(UCommon.uopencv2wxbitmap(self.cv_image, self.magnification))
			else:
				ret_img = self.cv_image.cvtColor(code)
				self.bitmap.SetBitmap(UCommon.uopencv2wxbitmap(ret_img, self.magnification))
		except Exception as e:
			wx.MessageBox(str(e), 'エラー', style=wx.ICON_ERROR)
