"""Subclass of EWin, which is generated by wxFormBuilder."""

import copy

import wx

import CL
import UCommon
from URubberBand import URubberBand

# Implementing EWin
class UEWin(URubberBand, CL.EWin ):
	def __init__( self, parent ):
		CL.EWin.__init__( self, parent )
		URubberBand.__init__(self, self.m_bitmap1)
		self.parent = parent  # 親ウインドウの関数を使うため

	# Handlers for EWin events.
	def OnMvEnd( self, event ):
		# TODO: Implement OnMvEnd
		pos = self.GetPosition()
		self.parent.ChildWinPoint = pos + wx.Point(20,20)

	def OnOpen( self, event ):
		# TODO: Implement OnOpen
		self.parent.OpenImgFile()

	def OnSaveAs( self, event ):
		# TODO: Implement OnSaveAs
		UCommon.SaveAs(self)

	def OnWClose( self, event ):
		# TODO: Implement OnWClose
		self.Close()

	def OnExit( self, event ):
		# TODO: Implement OnExit
		self.parent.OnExit(event)

	def OnCopy( self, event ):
		# TODO: Implement OnCopy
		UCommon.CopyToClipboard(self.cv_image)

	def OnPaste( self, event ):
		# TODO: Implement OnPaste
		self.parent.CopyFromClipboard()

	def OnZoomIn( self, event ):
		# TODO: Implement OnZoomIn
		UCommon.ZoomIn(self)

	def OnZoomOut( self, event ):
		# TODO: Implement OnZoomOut
		UCommon.ZoomOut(self)

	def OnZoomRst( self, event ):
		# TODO: Implement OnZoomRst
		UCommon.ZoomRst(self)

	def OnViewLog( self, event ):
		# TODO: Implement OnViewLog
		self.parent.LogDlg.DispLog(self.cv_image)

	def OnGray( self, event ):
		# TODO: Implement OnGray
		self.parent.NewGrayWindow(self.cv_image.grayscale(), self.magnification)
		self.parent.SetWinTitle(self)

	def OnIFFT( self, event ):
		# TODO: Implement OnIFFT
		if self.cv_image.kind != 'fft':
			wx.MessageBox('FFT画像でなければ処理できません', 'エラー', wx.ICON_ERROR)
			return
		win = self.parent.NewGrayWindow(self.cv_image, self.magnification)
		self.parent.IFFTDlg.cv_image = win.cv_image
		self.parent.IFFTDlg.bitmap   = win.m_bitmap1
		self.parent.IFFTDlg.magnification = win.magnification
		ret = self.parent.IFFTDlg.ShowModal()
		if ret == 1:
			win.cv_image = copy.deepcopy(self.parent.IFFTDlg.cv_image)
			self.parent.SetWinTitle(win)
		else:
			win.Destroy()

	def OnHist( self, event ):
		# TODO: Implement OnHist
		self.cv_image.calcHist()
		self.parent.RetDlg.HistResult(self.cv_image)
		UCommon.showHist(self.cv_image)

	def OnDistH( self, event ):
		# TODO: Implement OnDistH
		self.cv_image.projection_distribution_h()
		self.parent.RetDlg.DistResult(self.cv_image)
		UCommon.showDist(self.cv_image)

	def OnDistV( self, event ):
		# TODO: Implement OnDistV
		self.cv_image.projection_distribution_v()
		self.parent.RetDlg.DistResult(self.cv_image)
		UCommon.showDist(self.cv_image)

	def OnHistArea( self, event ):
		# TODO: Implement OnHistArea
		self.SetCursor(wx.Cursor(wx.CURSOR_CROSS))
		self.draw_type = URubberBand.Rectangle
		self.func_type = URubberBand.HistArea

	def OnDistHArea( self, event ):
		# TODO: Implement OnDistHArea
		self.SetCursor(wx.Cursor(wx.CURSOR_CROSS))
		self.draw_type = URubberBand.Rectangle
		self.func_type = URubberBand.DistHArea

	def OnDistVArea( self, event ):
		# TODO: Implement OnDistVArea
		self.SetCursor(wx.Cursor(wx.CURSOR_CROSS))
		self.draw_type = URubberBand.Rectangle
		self.func_type = URubberBand.DistVArea

	def OnLine( self, event ):
		# TODO: Implement OnLine
		self.SetCursor(wx.Cursor(wx.CURSOR_CROSS))
		self.draw_type = URubberBand.Line
		self.func_type = URubberBand.DistLine

	def OnPixcel( self, event ):
		# TODO: Implement OnPixcel
		self.parent.PixDlg.Show(True)

	def OnAbout( self, event ):
		# TODO: Implement OnAbout
		UCommon.About()

	def OnLDwn( self, event ):
		# TODO: Implement OnLDwn
		if self.parent.PixDlg.IsShown():  # ピクセル表示ならば
			pos = event.GetPosition()
			x = int(pos.x / self.magnification)
			y = int(pos.y / self.magnification)
			self.parent.PixDlg.View(self, x, y)
		if self.draw_type != URubberBand.NoRubber:  # ラバーバンド表示ならば
			URubberBand.OnMLDown(self,  event )

	def OnLUp( self, event ):
		# TODO: Implement OnLUp
		if self.drag_flag:
			URubberBand.OnMLUp( self, event )
			self.SetCursor(wx.Cursor(wx.CURSOR_ARROW))
			bx = int(self.begin_pos.x / self.magnification)
			by = int(self.begin_pos.y / self.magnification)
			ex = int(self.end_pos.x   / self.magnification)
			ey = int(self.end_pos.y   / self.magnification)
			if   self.func_type == URubberBand.HistArea:
				self.cv_image.calcHist(bx, by, ex, ey)
				self.parent.RetDlg.HistResult(self.cv_image, bx, by, ex, ey)
				UCommon.showHist(self.cv_image)
			elif self.func_type == URubberBand.DistHArea:
				self.cv_image.projection_distribution_h(bx, by, ex, ey)
				self.parent.RetDlg.DistResult(self.cv_image, bx, by, ex, ey)
				UCommon.showDist(self.cv_image)
			elif self.func_type == URubberBand.DistVArea:
				self.cv_image.projection_distribution_v(bx, by, ex, ey)
				self.parent.RetDlg.DistResult(self.cv_image, bx, by, ex, ey)
				UCommon.showDist(self.cv_image)
			elif self.func_type == URubberBand.DistLine:
				self.cv_image.get_line_data(bx, by, ex, ey)
				self.parent.RetDlg.GetLineResult(self.cv_image, bx, by, ex, ey)
				UCommon.showLine(self.cv_image)

	def OnMove( self, event ):
		# TODO: Implement OnMove
		if self.drag_flag:
			if self.parent.PixDlg.IsShown():  # ピクセル表示ならば
				pos = event.GetPosition()
				x = int(pos.x / self.magnification)
				y = int(pos.y / self.magnification)
				self.parent.PixDlg.View(self, x, y)
			URubberBand.OnMMotion( self, event )
