"""Subclass of IFFTDlg, which is generated by wxFormBuilder."""

import wx

import CL
import UCommon
from UOpenCV import UOpenCV

# Implementing IFFTDlg
class UIFFTDlg( CL.IFFTDlg ):
	def __init__( self, parent ):
		CL.IFFTDlg.__init__( self, parent )
		self.mask_image = None  # マスク画像

	# Handlers for IFFTDlg events.
	def OnCancel( self, event ):
		# TODO: Implement OnCancel
		self.EndModal(0)

	def OnFOpen( self, event ):
		# TODO: Implement OnFOpen
		mask_name = self.m_filePicker6.GetPath()
		self.mask_image = UOpenCV(mask_name)
		fx = 300 / self.mask_image.width
		fy = 270 / self.mask_image.height
		f  = min(fx, fy)
		disp_image = self.mask_image.resize(f, f)
		self.m_bitmap14.SetBitmap(UCommon.uopencv2wxbitmap(disp_image, 1.0))

	def OnPreView( self, event ):
		# TODO: Implement OnPreView
		self.Execute(False)

	def OnExec( self, event ):
		# TODO: Implement OnExec
		self.Execute(True)
		self.EndModal(1)

	def Execute(self, Flag):
		"""処理実行
		"""
		if self.m_checkBox1.GetValue():  # マスクを使う
			mask = self.mask_image
		else:
			mask = None
		try:
			if Flag:
				self.cv_image = self.cv_image.idft(mask)
				self.bitmap.SetBitmap(UCommon.uopencv2wxbitmap(self.cv_image, self.magnification))
			else:
				ret_img = self.cv_image.idft(mask)
				self.bitmap.SetBitmap(UCommon.uopencv2wxbitmap(ret_img, self.magnification))
		except Exception as e:
				wx.MessageBox(str(e), 'エラー', wx.ICON_ERROR)
