"""Subclass of PixDlg, which is generated by wxFormBuilder."""

import wx

import CL

# Implementing PixDlg
class UPixDlg( CL.PixDlg ):
	def __init__( self, parent ):
		CL.PixDlg.__init__( self, parent )
		self.parent = parent  # 親ウインドウを覚えておく

	# Handlers for PixDlg events.
	def OnView( self, event ):
		# TODO: Implement OnView
		win = self.parent.GetActiveChild()
		if win is None:
			wx.MessageBox('アクティブな画像がありません', 'エラー', style=wx.ICON_ERROR)
			return
		x = self.m_spinCtrl1.GetValue()
		y = self.m_spinCtrl2.GetValue()
		rect = wx.Rect(0, 0, win.cv_image.width, win.cv_image.height)
		if rect.Contains(x, y) is False:
			wx.MessageBox('範囲外の座標です', 'エラー', style=wx.ICON_ERROR)
			return
		self.ViewData(win, x, y)

	def View(self, win, x, y):
		"""指定された座標をスピンコントロールに設定する
		"""
		self.m_spinCtrl1.SetValue(x)
		self.m_spinCtrl2.SetValue(y)
		self.ViewData(win, x, y)

	def ViewData(self, win, x, y):
		"""指定された座標近傍のデータを表示する
		"""
		rect = wx.Rect(0, 0, win.cv_image.width, win.cv_image.height)
		if rect.Contains(x, y) is False:
			return
		data = win.cv_image.get7data(x, y)
		if win.cv_image.kind == 'color':
			for i in range(0, 7):      # i行(yの値)
				for j in range(0, 7):  # j列(xの値)
					self.m_grid1.SetCellValue(i, j, str(data[i][j][::-1]))  # [::-1]はスライスによって逆順に並べ替え  @link https://note.nkmk.me/python-reverse-reversed/ (2022/04/17)
		else:
			for i in range(0, 7):      # i行(yの値)
				for j in range(0, 7):  # j列(xの値)
					self.m_grid1.SetCellValue(i, j, str(data[i][j]))
		for i in range(0, 7):
			self.m_grid1.SetRowLabelValue(i, str(y-3+i))
		for j in range(0, 7):
			self.m_grid1.SetColLabelValue(j, str(x-3+j))
